618dd877e3a9d3fbfd736bb94a11afe4c2725b85
[dpdk.git] / devtools / test-meson-builds.sh
1 #! /bin/sh -e
2 # SPDX-License-Identifier: BSD-3-Clause
3 # Copyright(c) 2018 Intel Corporation
4
5 # Run meson to auto-configure the various builds.
6 # * all builds get put in a directory whose name starts with "build-"
7 # * if a build-directory already exists we assume it was properly configured
8 # Run ninja after configuration is done.
9
10 # set pipefail option if possible
11 PIPEFAIL=""
12 set -o | grep -q pipefail && set -o pipefail && PIPEFAIL=1
13
14 srcdir=$(dirname $(readlink -f $0))/..
15 MESON=${MESON:-meson}
16 use_shared="--default-library=shared"
17
18 if command -v gmake >/dev/null 2>&1 ; then
19         MAKE=gmake
20 else
21         MAKE=make
22 fi
23 if command -v ninja >/dev/null 2>&1 ; then
24         ninja_cmd=ninja
25 elif command -v ninja-build >/dev/null 2>&1 ; then
26         ninja_cmd=ninja-build
27 else
28         echo "ERROR: ninja is not found" >&2
29         exit 1
30 fi
31
32 build () # <directory> <target compiler> <meson options>
33 {
34         builddir=$1
35         shift
36         targetcc=$1
37         shift
38         # skip build if compiler not available
39         command -v $CC >/dev/null 2>&1 || return 0
40         command -v $targetcc >/dev/null 2>&1 || return 0
41         if [ ! -f "$builddir/build.ninja" ] ; then
42                 options="--werror -Dexamples=all $*"
43                 echo "$MESON $options $srcdir $builddir"
44                 $MESON $options $srcdir $builddir
45                 unset CC
46         fi
47         if [ -n "$TEST_MESON_BUILD_VERY_VERBOSE" ] ; then
48                 # for full output from ninja use "-v"
49                 echo "$ninja_cmd -v -C $builddir"
50                 $ninja_cmd -v -C $builddir
51         elif [ -n "$TEST_MESON_BUILD_VERBOSE" ] ; then
52                 # for keeping the history of short cmds, pipe through cat
53                 echo "$ninja_cmd -C $builddir | cat"
54                 $ninja_cmd -C $builddir | cat
55         else
56                 echo "$ninja_cmd -C $builddir"
57                 $ninja_cmd -C $builddir
58         fi
59 }
60
61 if [ "$1" = "-vv" ] ; then
62         TEST_MESON_BUILD_VERY_VERBOSE=1
63 elif [ "$1" = "-v" ] ; then
64         TEST_MESON_BUILD_VERBOSE=1
65 fi
66 # we can't use plain verbose when we don't have pipefail option so up-level
67 if [ -z "$PIPEFAIL" -a -n "$TEST_MESON_BUILD_VERBOSE" ] ; then
68         echo "# Missing pipefail shell option, changing VERBOSE to VERY_VERBOSE"
69         TEST_MESON_BUILD_VERY_VERBOSE=1
70 fi
71
72 # shared and static linked builds with gcc and clang
73 for c in gcc clang ; do
74         command -v $c >/dev/null 2>&1 || continue
75         for s in static shared ; do
76                 export CC="ccache $c"
77                 build build-$c-$s $c --default-library=$s
78         done
79 done
80
81 # test compilation with minimal x86 instruction set
82 # Set the install path for libraries to "lib" explicitly to prevent problems
83 # with pkg-config prefixes if installed in "lib/x86_64-linux-gnu" later.
84 default_machine='nehalem'
85 ok=$(cc -march=$default_machine -E - < /dev/null > /dev/null 2>&1 || echo false)
86 if [ "$ok" = "false" ] ; then
87         default_machine='corei7'
88 fi
89 build build-x86-default cc -Dlibdir=lib -Dmachine=$default_machine $use_shared
90
91 c=aarch64-linux-gnu-gcc
92 # generic armv8a with clang as host compiler
93 export CC="clang"
94 build build-arm64-host-clang $c $use_shared \
95         --cross-file $srcdir/config/arm/arm64_armv8_linux_gcc
96 # all gcc/arm configurations
97 for f in $srcdir/config/arm/arm*gcc ; do
98         export CC="ccache gcc"
99         build build-$(basename $f | tr '_' '-' | cut -d'-' -f-2) $c \
100                 $use_shared --cross-file $f
101 done
102
103 # Test installation of the x86-default target, to be used for checking
104 # the sample apps build using the pkg-config file for cflags and libs
105 build_path=build-x86-default
106 export DESTDIR=$(pwd)/$build_path/install-root
107 $ninja_cmd -C $build_path install
108
109 pc_file=$(find $DESTDIR -name libdpdk.pc)
110 export PKG_CONFIG_PATH=$(dirname $pc_file):$PKG_CONFIG_PATH
111
112 for example in cmdline helloworld l2fwd l3fwd skeleton timer; do
113         echo "## Building $example"
114         $MAKE -C $DESTDIR/usr/local/share/dpdk/examples/$example clean all
115 done